#include "adddialog.h"
#include "ui_adddialog.h"
#include "mainwindow.h"
#include "QMessageBox"
#include "phonon/MediaObject"
#include "phonon/AudioOutput"
#include <QtCore/QFile>
#include <QDir>
#include <QTimer>
#include "QTableWidgetItem"
#include <QSettings>

Phonon::MediaObject *TestMusic;
Phonon::AudioOutput *TestAudioOutput;
QTimer *timer;
QTableWidget *TestTableWidget;
QString PathToStationsDir2;
QString PathToStationsFile2;

//------------------------------------------------------------------------------------
AddDialog::AddDialog(QWidget *parent) : QDialog(parent), ui(new Ui::AddDialog)
{
     ui->setupUi(this);

     QSettings temp_settings("glrp", "Great Little Radio Player");
     temp_settings.beginGroup("OtherSettings");
     ReadLanguage(temp_settings.value("UILanguage", "English").toString());
     temp_settings.endGroup();

     AddCancelTriger = false;
         timer = new QTimer(this);
         connect(timer, SIGNAL(timeout()), this, SLOT(ChangePlayingStatus()));

         TestMusic = Phonon::createPlayer(Phonon::MusicCategory,Phonon::MediaSource());
         TestAudioOutput = new Phonon::AudioOutput(Phonon::MusicCategory, this);

         //Tabela
         TestTableWidget = new QTableWidget();

         PathToStationsDir2 = QDir::homePath() + "/.config/glrp/";
         PathToStationsFile2 = PathToStationsDir2 + "stations.csv";

         QFile f( PathToStationsFile2 );

             if( f.open( QIODevice::ReadOnly ) ){
                 QTextStream ts( &f );
                 QList<QStringList> list;
                 int row = 0, col = 0;


                 while( !ts.atEnd() ){
                     list << ts.readLine().split( "," );
                 }

                 f.close();

                 TestTableWidget->setRowCount( list.count() );
                 TestTableWidget->setColumnCount( list[0].count() );

                 TestTableWidget->setUpdatesEnabled( false );
                 foreach( QStringList l, list ){
                     foreach( QString str, l ){

                         if( str.endsWith( '"' ) ) str.chop(1);
                         if( str.startsWith( '"' ) ) str.remove(0,1);
                         TestTableWidget->setItem( row, col++, new QTableWidgetItem( str ));
                     }
                     row++; col=0;
                 }
                 TestTableWidget->setUpdatesEnabled( true );
             }
         //Kraj Tabele

         ui->TestButton->setEnabled(false);
         ClearFields();
         ui->labelTestStatus->hide();

         QString Image("<img src=':/images/IMG/add.png'/>");
         ui->MainLabel->setText("<table><tr><td align=center width='70'>" + QString(Image) + "</td><td align=justify><font size=4>" + QString(Title) + "</font><br>" + QString(Info_a + TestItButtonTextGo + Info_b) + "</td></tr></table>");
         setWindowTitle(Title);

         ui->buttonBox->setCenterButtons(true);
         ui->buttonBox->clear();

         QPushButton *CancelButton = new QPushButton(CancelButtonText);
         CancelButton->setAutoDefault(false);
         connect(CancelButton, SIGNAL(clicked()), this, SLOT(pushButton_clicked()));

         QPushButton *ResetButton = new QPushButton(ResetButtonText);
         ResetButton->setDefault(false);
         connect(ResetButton, SIGNAL(clicked()), this, SLOT(clearfeeldsButton_clicked()));

         QPushButton *AddButton = new QPushButton(AddButtonText);
         AddButton->setDefault(true);
         connect(AddButton, SIGNAL(clicked()), this, SLOT(AddButton_clicked()));

         ui->buttonBox->addButton(CancelButton, QDialogButtonBox::RejectRole);
         ui->buttonBox->addButton(ResetButton, QDialogButtonBox::ActionRole);
         ui->buttonBox->addButton(AddButton, QDialogButtonBox::AcceptRole);
}

//------------------------------------------------------------------------------------
AddDialog::~AddDialog()
{
    TestMusic->stop();
    delete ui;
}

//------------------------------------------------------------------------------------
void AddDialog::AddButton_clicked()
{
    if ((!ui->StationName_lineEdit->text().isEmpty()) && (!ui->StationAddress_lineEdit->text().isEmpty()) && (!ui->GenrecomboBox->currentText().isEmpty()) && (!ui->CountryComboBox->currentText().isEmpty()))
            {
            QMessageBox msgBox;
            msgBox.setIcon(QMessageBox::Question);
            QPushButton *savestationButton = msgBox.addButton(SaveStationButtonText, QMessageBox::ActionRole);
            QPushButton *CancelButton = msgBox.addButton(CancelButtonText, QMessageBox::RejectRole);
            //msgBox.setStandardButtons(QMessageBox::Cancel | QMessageBox::Apply);
            msgBox.setText(SaveStationDialogText);

            QString s(ui->StationAddress_lineEdit->text());
            QString startaddress(s.mid(0,25));
            int i = s.length();
            QString endaddress(s.mid((i -5),i));

            msgBox.setInformativeText(SName + ui->StationName_lineEdit->text() + "\n" + SAddress + startaddress + " ... " + endaddress + "\n" + SGenre + ui->GenrecomboBox->currentText() + "\n" + SRegion + ui->CountryComboBox->currentText() + "\n\n" + SaveStationConfirmDialog);
            msgBox.setDefaultButton(savestationButton);
            int ret = msgBox.exec();

            if (msgBox.clickedButton() == savestationButton)
                {
                StationName = ui->StationName_lineEdit->text();
                StationAddress = ui->StationAddress_lineEdit->text();
                StationGenre = ui->GenrecomboBox->currentText();
                StationCountry = ui->CountryComboBox->currentText();

                AddCancelTriger = true;

                TestMusic->stop();
                timer->stop();

                close();
                }
            }
        else
            {
             QMessageBox reactMsgBox;
             reactMsgBox.setText(SaveStationErrorDialogText);
             reactMsgBox.setInformativeText(SaveStationErrorDialogInfoText);
             reactMsgBox.setIcon(QMessageBox::Warning);
             reactMsgBox.exec();
            }
}
//------------------------------------------------------------------------------------

void AddDialog::pushButton_clicked()
{
    close();
}

//------------------------------------------------------------------------------------
void AddDialog::ClearFields()
{
    try
        {
        ui->StationName_lineEdit->setText("");
        ui->StationAddress_lineEdit->setText("");

        QStringList CountryStringList;
        QStringList GenreStringList;

        for (int i = 0; i < TestTableWidget->rowCount(); i++)
            {
            CountryStringList << TestTableWidget->item(i,3)->text();
            GenreStringList << TestTableWidget->item(i,2)->text();
            }

        CountryStringList.sort();
        CountryStringList.removeDuplicates();

        GenreStringList.sort();
        GenreStringList.removeDuplicates();

        ui->CountryComboBox->clear();
        ui->CountryComboBox->addItems(CountryStringList);
        ui->CountryComboBox->setCurrentIndex(0);

        ui->GenrecomboBox->clear();
        ui->GenrecomboBox->addItems(GenreStringList);
        ui->GenrecomboBox->setCurrentIndex(0);
        }
        catch(...){}
}

//------------------------------------------------------------------------------------
void AddDialog::TestStation()
{
    QString string = ui->StationAddress_lineEdit->text();
        QString extension = string.mid(string.length()-3,3);
        if ((extension == "pls") || (extension == "m3u") || (extension == "asx") || (extension == "html"))
        {
            QMessageBox msgBox;
            msgBox.setIcon(QMessageBox::Information);
            msgBox.setText(ExtensionErrorMSG_a + extension + ExtensionErrorMSG_b);
            msgBox.exec();
        }
        else
        {
            //Test station before insert
            if (ui->TestButton->text() == TestItButtonTextGo)
            {
                TestMusic->stop();
                TestMusic->setCurrentSource(Phonon::MediaSource(ui->StationAddress_lineEdit->text()));
                Phonon::AudioOutput *TestAudioOutput = new Phonon::AudioOutput(Phonon::MusicCategory, this);

                TestMusic->play();
                timer->start(1500);
                ui->TestButton->setText(TestItButtonTextStop);
                ui->labelTestStatus->show();
            }
            else
            {
                TestMusic->stop();
                ui->TestButton->setText(TestItButtonTextGo);
                ui->labelTestStatus->hide();
            }
        }
}
//------------------------------------------------------------------------------------

void AddDialog::on_TestButton_clicked()
{
    TestStation();
}

//------------------------------------------------------------------------------------
void AddDialog::ChangePlayingStatus()
{
    if (TestMusic->state() == Phonon::PlayingState)
        {
            ui->labelTestStatus->setText(PlayingStatusText + QString("<font color=green>") + PlayingStatusWorking + QString("</font>"));
        }
        else
        {
            ui->labelTestStatus->setText(PlayingStatusText + QString("<font color=red>") + PlayingStatusNotWorking + QString("</font>"));
            TestMusic->stop();
            timer->stop();
            ui->TestButton->setText(TestItButtonTextGo);
        }
}

//------------------------------------------------------------------------------------
void AddDialog::on_StationAddress_lineEdit_textChanged(const QString &arg1)
{
    ui->labelTestStatus->hide();
        for (int i = 0; i < TestTableWidget->rowCount(); i++)
            {
            QString sourcestring(ui->StationAddress_lineEdit->text());
            QString deststring(TestTableWidget->item(i,1)->text());
            int stringletters = sourcestring.mid(0,sourcestring.length()-1).length();
            if (sourcestring.mid(0,stringletters) == deststring.mid(0,stringletters))
                {
                ui->label_3->setText(Adress + QString("<font color=red><i>") + AdressNotValid + QString("</i></font><br>") + AdressInUse + QString(TestTableWidget->item(i,0)->text()) + ".");
                ui->TestButton->setEnabled(false);
                break;
                }
            else
                {
                ui->label_3->setText(Adress + QString("<font color=green><i>") + AdressValid + QString("</i></font>") + AdressNotInUse);
                ui->TestButton->setEnabled(true);
                }
            }
}

//------------------------------------------------------------------------------------
void AddDialog::clearfeeldsButton_clicked()
{
    ClearFields();
}

//------------------------------------------------------------------------------------
void AddDialog::ReadLanguage(QString Language)
{
    //Language Settings - MainWindow
    QSettings LangSettings("glrp/language", Language);
    LangSettings.beginGroup("AddNewStation");
    TestItButtonTextGo = LangSettings.value("TestItButtonTextGo", "Test it...").toString();
    TestItButtonTextStop = LangSettings.value("TestItButtonTextStop","Stop testing").toString();
    Info_a = LangSettings.value("AddNewStationInfo_a", "This is Add New Station Dialog. It accept only valid URL. Playlists are not supported. Please, when you testing a station, be sure that you clicked '").toString();
    Info_b = LangSettings.value("AddNewStationInfo_b", "' button several times. It is necessary for properly testing station URL.").toString();
    Title = LangSettings.value("AddNewStationTitle", "Add New Station").toString();
    SaveStationButtonText = LangSettings.value("SaveStationButtonText", "Save this station right now").toString();
    SaveStationDialogText = LangSettings.value("SaveStationDialogText", "If you are sure that you want to add new radio station to the collection, and you properly tested it, please confirm.<br>Here is what is going to be stored:").toString();
    SaveStationConfirmDialog = LangSettings.value("SaveStationConfirmDialog", "Do you want to save this station?").toString();
    SaveStationErrorDialogText = LangSettings.value("SaveStationErrorDialogText", "Warning! Some station data is not entered correctly and new station is not saved! Sorry!").toString();
    SaveStationErrorDialogInfoText = LangSettings.value("SaveStationErrorDialogInfoText", "Try insert data in every fields next time, please!").toString();
    ExtensionErrorMSG_a = LangSettings.value("ExtensionErrorMSG_a", "Sorry, extension: '").toString();
    ExtensionErrorMSG_b = LangSettings.value("ExtensionErrorMSG_b", "' is not implemented yet!\nOnly clean single station, no playlists!").toString();
    PlayingStatusText = LangSettings.value("PlayingStatusText", "Station address status: ").toString();
    PlayingStatusWorking = LangSettings.value("PlayingStatusWorking", "Working!").toString();
    PlayingStatusNotWorking = LangSettings.value("PlayingStatusNotWorking","Not Working!").toString();

    Adress = LangSettings.value("Adress","Address: ").toString();
    AdressInUse = LangSettings.value("AdressInUse","Similar or same address is already in use by the following radio station: ").toString();
    AdressNotInUse = LangSettings.value("AdressNotInUse"," (Not in collection).").toString();
    AdressValid = LangSettings.value("AdressValid","Valid").toString();
    AdressNotValid = LangSettings.value("AdressNotValid","Not Valid!").toString();

    SName = LangSettings.value("SName","Name: ").toString();
    SAddress = LangSettings.value("SAddress","Address: ").toString();
    SGenre = LangSettings.value("SGenre","Genre: ").toString();
    SRegion = (LangSettings.value("SRegion","Country/Region: ").toString());

    ui->label_2->setText(SName);
    ui->label_3->setText(SAddress);
    ui->label_4->setText(SGenre);
    ui->label_5->setText(SRegion);
    ui->tabWidget->setTabText(0,LangSettings.value("AddNewStationTabText","Internet Radio Station Informations").toString());
    ui->TestButton->setText(TestItButtonTextGo);

    CancelButtonText = LangSettings.value("CancelButtonText","Cancel").toString();
    AddButtonText = LangSettings.value("AddButtonText","Add").toString();
    ResetButtonText = LangSettings.value("ResetButtonText","Reset").toString();
    LangSettings.endGroup();

}

void AddDialog::on_label_linkActivated(const QString &link)
{

}
