#ifndef SETTINGS_H
#define SETTINGS_H

#include <QDialog>

namespace Ui {
class Settings;
}

class Settings : public QDialog
{
    Q_OBJECT
    
public:
    explicit Settings(QWidget *parent = 0);
    //Settings variable
    bool HideAppCheckBox;
    bool  PlayStationRadioButton;
    QString PlayThisStationComboBox;
    bool PlayLastStationRadioButton;
    bool PlayStationAutomaticly;
    bool ShowStationsSystemTray;
    bool ShowSystemTrayMessage;
    QString UILanguage;

    //Language Settings - Settings
    QString LangSettingsTitle;
    QString LangSettingsInfo;
    QString CancelButtonText;
    QString OKButtonText;



    ~Settings();
    
private slots:

    void on_buttonBox_accepted();

    void readSettings();

    void on_PlayStationRadioButton1_toggled(bool checked);

    void LoadStationsToAutoPlayList();

    void on_PlayThisStationComboBox1_currentIndexChanged(const QString &arg1);

    void ReadLanguage(QString Language);

    void on_PlayStationAutomaticly1_toggled(bool arg1);

private:
    Ui::Settings *ui;
};

#endif // SETTINGS_H
